//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "pce_sdk_main.h"
#include "pce_sdk2.h"
#include "pce_sdk_option.h"
#include "pce_sdk_about.h"

//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
	: TForm(Owner)
{
	LoadIni();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Quit1Click(TObject *Sender)
{
	Close();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::SaveAs1Click(TObject *Sender)
{
	FILE* f;
	if (!SaveDialog1->Execute())
    	return;
    f = fopen(SaveDialog1->FileName.c_str(),"wt");
    if (!f)
    	{
        	Application->MessageBox(
              "Can't open file to write in it",
              "Save file error",
              MB_ICONEXCLAMATION
              );
            return;
        }
     fclose(f);

    ((TFormEdit*)ActiveMDIChild)->RichEdit1->Lines->SaveToFile(
     	SaveDialog1->FileName.c_str());
	((TFormEdit*)ActiveMDIChild)->NewOne = false;
	((TFormEdit*)ActiveMDIChild)->Caption = SaveDialog1->FileName.c_str();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Open1Click(TObject *Sender)
{

    TFormEdit* form;

    OpenDialog1->Filter = "C files (*.c)|*.c|Assembler files (*.s, *.asm)|"
                          "*.s;*.asm|All files (*.*)|*.*";

	if (!OpenDialog1->Execute())
    	return;

	form = new TFormEdit(Form1);

	form->RichEdit1->Lines->LoadFromFile(OpenDialog1->FileName);

    form->Caption = OpenDialog1->FileName.c_str();

    form->NewOne = false;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Save1Click(TObject *Sender)
{

	if (((TFormEdit*)ActiveMDIChild)->NewOne)
        SaveAs1Click(Sender);
    else
      {
		((TFormEdit*)ActiveMDIChild)->RichEdit1->Lines->SaveToFile(
    		ActiveMDIChild->Caption);
    	((TFormEdit*)ActiveMDIChild)->modified = false;
      }
    UpdateStatus();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Close1Click(TObject *Sender)
{
	delete ActiveMDIChild;

    SetStatus("Window destroyed.");
}
//---------------------------------------------------------------------------
void __fastcall TForm1::New1Click(TObject *Sender)
{
	new TFormEdit(Form1);

    SetStatus("New window created.");
}
//---------------------------------------------------------------------------
void UpdateStatus()
{
	if (((TFormEdit*)Form1->ActiveMDIChild)->modified)
    	Form1->StatusBar1->Panels->Items[1]->Text = "Modified";
    else
    	Form1->StatusBar1->Panels->Items[1]->Text = " ";
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Cut1Click(TObject *Sender)
{
	((TFormEdit*)ActiveMDIChild)->RichEdit1->CutToClipboard();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Copy1Click(TObject *Sender)
{
	((TFormEdit*)ActiveMDIChild)->RichEdit1->CopyToClipboard();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Paste1Click(TObject *Sender)
{
	((TFormEdit*)ActiveMDIChild)->RichEdit1->PasteFromClipboard();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Clear1Click(TObject *Sender)
{
	((TFormEdit*)ActiveMDIChild)->RichEdit1->ClearSelection();
}
//---------------------------------------------------------------------------
// Be careful, this function returns allocated memory
// Don't forget to free the return value of it
char* GetINIFilename()
{
	char*s = (char*)malloc(Application->ExeName.Length() + 4);
    strcpy(s,Application->ExeName.c_str());
    
	if (strrchr(s, '.'))
       	strcpy(strrchr(s,'.'),".ini");
    else
    	strcat(s,".ini");
        
	return s;
}
//---------------------------------------------------------------------------
void LoadIni()
{
	TStringList* INIval = new TStringList;
	char* inifile = GetINIFilename();
    FILE *f=fopen(inifile,"r");
    int i;
    AnsiString S;

    if (!f)
    	{
        	free(inifile);
            return;
        }
    fclose(f);

    INIval->LoadFromFile(inifile);

    for (i=0; i<5; i++)
    {
      S = "emu";
      S += i;
      if (INIval->Values[S] != "")
        Form1->CommandLineEmu[i] = INIval->Values[S];
    }

    Form1->CommandLineCc = INIval->Values["pcecc"];

    Form1->CommandLineAs = INIval->Values["pceas"];

	free(inifile);
	delete INIval;
}
//---------------------------------------------------------------------------
void SaveIni()
{
	TStringList* INIval = new TStringList;
	char* inifile = GetINIFilename();
    AnsiString S;
    int i;

    for (i=0; i<5; i++)
    {
      S = "emu";
      S += i;
      S += "=";
      S += Form1->CommandLineEmu[i];
      INIval->Add(S);
    }

    S = "pcecc=";
    S += Form1->CommandLineCc;

	INIval->Add(S);

    S = "pceas=";
    S += Form1->CommandLineAs;

	INIval->Add(S);


    INIval->SaveToFile(inifile);

	free(inifile);
	delete INIval;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Loadoptions1Click(TObject *Sender)
{
    SetStatus("Loading preferences...");

	LoadIni();

    SetStatus("Preferences loaded.");
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Saveoptions1Click(TObject *Sender)
{
    SetStatus("Saving preferences...");

    SaveIni();

    SetStatus("Preferences saved.");
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Preferences1Click(TObject *Sender)
{
	FormOption->ShowModal();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Tile1Click(TObject *Sender)
{
	Tile();

    SetStatus("Tiling windows.");
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Cascade1Click(TObject *Sender)
{
	Cascade();

    SetStatus("Cascading windows.");
}
//---------------------------------------------------------------------------
void __fastcall TForm1::SetStatus(AnsiString S)
{
	Form1->StatusBar1->Panels->Items[2]->Text = S;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::CompileC1Click(TObject *Sender)
{
	AnsiString S;
    S = CommandLineCc + " " + ActiveMDIChild->Caption;

    SetStatus("Compiling " + ActiveMDIChild->Caption + " ...");

	system(S.c_str());

    SetStatus("Compiled " + ActiveMDIChild->Caption);

}
//---------------------------------------------------------------------------
void __fastcall TForm1::RunEmu(int i, AnsiString S)
{
	AnsiString CommandLine = CommandLineEmu[i] + " ";

    if (!HadExtension(S.c_str(),".pce"))
      {
      	char* TempCommand = (char*)malloc(strlen(S.c_str())+4);

        strcpy(TempCommand, S.c_str());

        if (strrchr(TempCommand,'.'))
        	*strrchr(TempCommand,'.')=0;

        strcat(TempCommand, ".pce");

        CommandLine += TempCommand;

        free(TempCommand);
      }
    else
    	CommandLine += S;
    system(CommandLine.c_str());
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Runwithemu01Click(TObject *Sender)
{
	RunEmu(0,ActiveMDIChild->Caption);
}
//---------------------------------------------------------------------------
bool __fastcall HadExtension(char* s, char* ext)
{
	if (!strrchr(s, '.'))
    	return false;
    return !stricmp(strrchr(s, '.') + 1, ext);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Smartcompile1Click(TObject *Sender)
{
	if (HadExtension(ActiveMDIChild->Caption.c_str(),"c"))
		CompileC1Click(Sender);
    else if (HadExtension(ActiveMDIChild->Caption.c_str(),"s") ||
    	     HadExtension(ActiveMDIChild->Caption.c_str(),"asm"))
		Compileasm1Click(Sender);
    else
        Application->MessageBox("Can't determine file type",
        						"Smart compiling aborted",
								MB_ICONERROR);                                
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Compileasm1Click(TObject *Sender)
{

	AnsiString S;
    S = CommandLineAs + " " + ActiveMDIChild->Caption;

    SetStatus("Compiling " + ActiveMDIChild->Caption + " ...");

	system(S.c_str());

    SetStatus("Compiled " + ActiveMDIChild->Caption);

}
//---------------------------------------------------------------------------
void __fastcall TForm1::Runwithemu11Click(TObject *Sender)
{
	RunEmu(1,ActiveMDIChild->Caption);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Runwithemu21Click(TObject *Sender)
{
	RunEmu(2,ActiveMDIChild->Caption);	
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Runwithemu31Click(TObject *Sender)
{
	RunEmu(3,ActiveMDIChild->Caption);	
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Runwithemu41Click(TObject *Sender)
{
	RunEmu(4,ActiveMDIChild->Caption);	
}
//---------------------------------------------------------------------------
void __fastcall TForm1::About1Click(TObject *Sender)
{
	FormAbout->ShowModal();	
}
//---------------------------------------------------------------------------
